#
# Conditional build:
%bcond_without	system_expat	# system expat
%bcond_without	system_freetype	# system freetype
%bcond_without	system_jbig2dec	# system jbig2dec
%bcond_with	system_lcms2	# system lcms2
%bcond_with	system_libjpeg	# system libjpeg (incompatible with D_MAX_BLOCKS_IN_MCU=64 variant)
%bcond_with	system_libtiff	# system libtiff (incompatible with modified libjpeg)
%bcond_without	system_openjp2	# system openjpeg2
%bcond_without	system_tesseract	# system tesseract+leptonlib
#
Summary:	PostScript, PDF and XPS interpreter and renderer
Summary(pl.UTF-8):	Interpreter i renderer PostScriptu, PDF oraz XPS
Name:		ghostpdl
Version:	10.04.0
Release:	1
License:	AGPL v3+
Group:		Applications/Graphics
#Source0Download: https://github.com/ArtifexSoftware/ghostpdl-downloads/releases
Source0:	https://github.com/ArtifexSoftware/ghostpdl-downloads/releases/download/gs10040/%{name}-%{version}.tar.xz
# Source0-md5:	599e2cbbf492414d68d8462cfd911427
Patch0:		%{name}-fonts_locations.patch
Patch1:		%{name}-make.patch
Patch2:		%{name}-system-libs.patch
URL:		https://ghostscript.com/
BuildRequires:	autoconf >= 2.63
BuildRequires:	cups-devel >= 1.5
%{?with_system_expat:BuildRequires:	expat-devel >= 1:2.5.0}
BuildRequires:	fontconfig-devel
BuildRequires:	libidn-devel
%{?with_system_freetype:BuildRequires:	freetype-devel >= 1:2.13.0}
%{?with_system_jbig2dec:BuildRequires:	jbig2dec-devel >= 0.20}
%{?with_system_lcms2:BuildRequires:	lcms2-devel >= 2.10}
%{?with_system_libjpeg:BuildRequires:	libjpeg-devel >= 9e}
BuildRequires:	libpaper-devel
BuildRequires:	libpng-devel >= 2:1.6.39
%{?with_system_libtiff:BuildRequires:	libtiff-devel >= 4.2.0}
%{?with_system_openjp2:BuildRequires:	openjpeg2-devel >= 2.4.0}
BuildRequires:	tar >= 1:1.22
%{?with_system_tesseract:BuildRequires:	tesseract-devel >= 4.1.0}
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXt-devel
BuildRequires:	xz
BuildRequires:	zlib-devel >= 1.2.13
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
GhostPCL is Artifex Software's implementation of the PCL-5(TM) and
PCL-XL(TM) family of page description languages. For more information
please see the documentation included with the source package.

%description -l pl.UTF-8
GhostPCL jest implementacją języków z rodzin PCL-5(TM) i PCL-XL(TM)
opisujących stronę. Więcej informacji znajduje się w dokumentacji
załączonej do pakietu.

%package -n ghostpcl
Summary:	PCL-5 and PCL-XL implementation
Summary(pl.UTF-8):	Implementacja PCL-5 oraz PCL-XL
Group:		Applications/Graphics
URL:		http://ghostscript.com/GhostPCL.html
Requires:	cups-lib >= 1.5
%{?with_system_expat:Requires:	expat >= 1:2.5.0}
%{?with_system_freetype:Requires:	freetype >= 1:2.13.0}
Requires:	ghostscript = %{version}
%{?with_system_jbig2dec:Requires:	jbig2dec >= 0.20}
%{?with_system_libjpeg:Requires:	libjpeg >= 9e}
Requires:	libpng >= 2:1.6.39
%{?with_system_libtiff:Requires:	libtiff >= 4.2.0}
%{?with_system_openjp2:Requires:	openjpeg2 >= 2.4.0}
Requires:	zlib >= 1.2.13
Suggests:	fonts-TTF-urw
Conflicts:	ghostpcl < 9

%description -n ghostpcl
GhostPCL is Artifex Software's implementation of the PCL-5 and PCL-XL
family of page description languages.

%description -n ghostpcl -l pl.UTF-8
GhostPCL to rozwijana przez Artifex Software implementacja rodzin
języków opisu strony PCL-5 oraz PCL-XL.

%package -n ghostxps
Summary:	XPS document format implementation based on Ghostscript
Summary(pl.UTF-8):	Implementacja formatu dokumentów XPS oparta na Ghostscripcie
Group:		Applications/Graphics
URL:		http://ghostscript.com/GhostXPS.html
Requires:	cups-lib >= 1.5
%{?with_system_expat:Requires:	expat >= 1:2.5.0}
%{?with_system_freetype:Requires:	freetype >= 1:2.13.0}
Requires:	ghostscript = %{version}
%{?with_system_jbig2dec:Requires:	jbig2dec >= 0.20}
%{?with_system_libjpeg:Requires:	libjpeg >= 9e}
Requires:	libpng >= 2:1.6.39
%{?with_system_libtiff:Requires:	libtiff >= 4.2.0}
%{?with_system_openjp2:Requires:	openjpeg2 >= 2.4.0}
Requires:	zlib >= 1.2.13

%description -n ghostxps
GhostXPS is an implementation of the Microsoft XPS document format
built on top of Ghostscript.

%description -n ghostxps -l pl.UTF-8
GhostXPS to implementacja formatu dokumentu XPS Microsoftu zbudowana w
oparciu o Ghostscript.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
# use system libs:
# expat 2.5.0
%{?with_system_expat:%{__rm} -r expat}
# freetype 2.13.0
%{?with_system_freetype:%{__rm} -r freetype}
# jbig2dec 0.20
%{?with_system_jbig2dec:%{__rm} -r jbig2dec}
# (unmodified) libpng 1.6.39 and zlib 1.2.13
%{__rm} -r libpng zlib
# libjpeg 9e (with additional CLAMP_DC) is built with different configuration (D_MAX_BLOCKS_IN_MCU=64)
%{?with_system_libjpeg:%{__rm} -r jpeg}
# lcms2mt is thread safe version of lcms2 2.10
%{?with_system_lcms:%{__rm} -r lcms2mt}
# openjpeg 2.4.0
%{?with_system_openjp2:%{__rm} -r openjpeg}
# tesseract 5.0.0-alpha-20201231, leptonica 1.81.0-git
%{?with_system_tesseract:%{__rm} -r tesseract leptonica}
# libtiff 4.5.0rc2
%{?with_system_libtiff:%{__rm} -r tiff}

%{__autoconf}
%configure \
	%{?with_system_libtiff:--with-system-libtiff}

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install pcl/tools/{pcl2pdf,pcl2pdfwr,plot2pdf.sh} $RPM_BUILD_ROOT%{_bindir}
ln -sf gpcl6 $RPM_BUILD_ROOT%{_bindir}/pcl6

# packaged in ghostscript.spec
%{__rm} $RPM_BUILD_ROOT%{_bindir}/{dvipdf,eps2eps,gs*,lprsetup.sh,pdf2*,pf2afm,pfbtopfa,pphs,printafm,ps2*,unix-lpr.sh}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/{dvipdf,eps2eps,gs*,pdf2*,pf2afm,pfbtopfa,printafm,ps2*}.1
%{__rm} -r $RPM_BUILD_ROOT%{_datadir}/ghostscript
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/ghostscript

%clean
rm -rf $RPM_BUILD_ROOT

%files -n ghostpcl
%defattr(644,root,root,755)
%doc doc/pclxps/ghostpdl.pdf pcl/{LICENSE,NEWS,README.txt} pcl/pcl/Anomalies.txt pcl/pxl/{pxcet,pxdiff,pxfts,pxlib,pxspec}.txt
%attr(755,root,root) %{_bindir}/gpcl6
%attr(755,root,root) %{_bindir}/pcl2pdf
%attr(755,root,root) %{_bindir}/pcl2pdfwr
%attr(755,root,root) %{_bindir}/pcl6
%attr(755,root,root) %{_bindir}/plot2pdf.sh

%files -n ghostxps
%defattr(644,root,root,755)
%doc doc/pclxps/ghostpdl.pdf xps/TODO
%attr(755,root,root) %{_bindir}/gxps
%changelog
* Wed Sep 18 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ghostpdl.git;a=log;h=master

* Wed Sep 18 2024 Jan Palus <atler@pld-linux.org> fb08d55
- up to 10.04.0

* Mon Jul 15 2024 Jan Palus <atler@pld-linux.org> 8e50fd6
- up to 10.03.1

* Sun Oct 29 2023 Jakub Bogusz <qboosh@pld-linux.org> 3b35fe8
- updated to 10.02.0, default to system tesseract

* Fri Jun 24 2022 Jakub Bogusz <qboosh@pld-linux.org> 5c9a83d
- updated to 9.56.1

* Sat Nov 27 2021 Jakub Bogusz <qboosh@pld-linux.org> 981fda8
- updated to 9.55.0
- removed obsolete tiff patch

* Mon Apr 26 2021 Jakub Bogusz <qboosh@pld-linux.org> ce5464c
- rediffed

* Sun Apr 25 2021 Jakub Bogusz <qboosh@pld-linux.org> bc1c105
- updated to 9.54.0
- added tiff patch (disable libdeflate support in internal libtiff to fix linking)
- use system openjpeg2 by default

* Fri Sep 25 2020 Jakub Bogusz <qboosh@pld-linux.org> 18012a4
- updated to 9.53.1; use local libtiff (system libtiff is incompatible with local libjpeg)

* Wed Mar 25 2020 Jakub Bogusz <qboosh@pld-linux.org> b0de3d3
- updated to 9.52

* Sun Nov 25 2018 Jakub Bogusz <qboosh@pld-linux.org> c9d8913
- updated dependencies

* Wed Nov 21 2018 Adam Gołębiowski <adamg@pld-linux.org> 6545ec5
- updated to 9.26

* Sun Oct 21 2018 Jan Rękorajski <baggins@pld-linux.org> 838207c
- up to 9.25

* Sat Sep 22 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> e06b3a9
- release 3 (by relup.sh)

* Sat Sep 15 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 2739a24
- release 2 (by relup.sh)

* Sun Nov 26 2017 Jan Rękorajski <baggins@pld-linux.org> 5d6bc09
- fixed intall
- rel 1

* Fri Nov 24 2017 Jan Rękorajski <baggins@pld-linux.org> d030a5c
- up to 9.22

* Thu Nov 23 2017 Jan Rękorajski <baggins@pld-linux.org> cef4b58
- release 2 (by relup.sh)

* Tue Feb 07 2017 Jakub Bogusz <qboosh@pld-linux.org> db12861
- base package renamed from ghostpcl to ghostpdl, new URLs, updated to 9.20
- updated fonts_locations,make patches
- removed obsolete format-security patch
- added system-libs patch
- build ghostpcl and ghostxps packages

* Sat Jul 30 2016 Jakub Bogusz <qboosh@pld-linux.org> d981cfe
- urwfonts separated to fonts-TTF-urw.spec

* Wed Jul 27 2016 Jakub Bogusz <qboosh@pld-linux.org> dc8e126
- verbose files, postun for -urwfonts

